#pragma once

#include <stdio.h>
#include <string>
#include "func.h"

#define elif else if

using namespace std;

extern unsigned parsePosition, bracketsLevel;

extern const char *operations;
extern const char *spaces;

struct parseException
{
    const char *msg;
    unsigned position;
    parseException(string msg, unsigned position);
    void message();
};

bool inRange(char c, const char *s, unsigned len);
void skipSpaces(string expression);
Func *parseOneValue(string expression);
int parseBinaryOperation(string expression, int priority);
Func *parseString(string expression, int priority);
Func *parse(string s);
